package {
	import com.erikloyer.swing.*;
	import org.wiiflash.events.WiimoteEvent;
	import org.wiiflash.Wiimote;
	import flash.events.*;
	import flash.display.*;
	import flash.utils.Timer;

	/**
	 * Swing, Version 1.
 	 * An experiment in text manipulation with the Wii Remote.
	 * 
	 * @author: Erik Loyer
	 * @version: 1.0.0
	 */
	public class Swing extends Sprite
	{
		
		[Embed(source="swf/fonts.swf", fontName="Helvetica Neue")]
		public static var helveticaPlain:Class;
		[Embed(source="swf/fonts.swf", fontName="Helvetica Neue", fontWeight="bold")]
		public static var helveticaBold:Class;
		
		private static var _instance:Swing = null;						// singleton instance of the application.
		private var _wiimote:Wiimote;									// wiimote object
		private var _textLine:TextLine;									// moveable line of text
		private var _sprite:Sprite = new Sprite();						// containing sprite
		private var _controller:String = "wiimote";						// current control scheme
		private var _bg:Shape = new Shape();							// background color
		private var _textInput:TextInput;								// text input
		
		public function Swing()
		{
			
			Swing._instance = this;
			
			if (_controller == "wiimote") {
				_wiimote = new Wiimote();
				_wiimote.addEventListener(Event.CONNECT, onWiimoteConnect);
				_wiimote.connect();
			}
			
			var timer:Timer = new Timer(500, 1);
			timer.addEventListener(TimerEvent.TIMER, setup);
			timer.start();
			
		}
		
		/**
		 * Returns a singleton instance of the class.
		 */
		public static function getInstance():Swing {
			if (Swing._instance == null) {
				Swing._instance = new Swing();
			}
			return Swing._instance;
		}
		
		/**
		 * Called when the Wiimote connects.
		 */
		private function onWiimoteConnect(event:WiimoteEvent):void {
			_controller = "wiimote";
		}
		
		/**
		 * Gets the app ready to go.
		 */
		private function setup(event:TimerEvent):void {
			
			addChild(_sprite);
			
			_sprite.addChild(_bg);
			
			// create hanging line of text
			_textLine = new TextLine(400);
			_textLine.x = 880 / 2;
			_textLine.y = 620 / 2 - 75;
			_sprite.addChild(_textLine);
			
			// create text input screen
			_textInput = new TextInput();
			_sprite.addChild(_textInput);
			_textInput.show();
			
		}
		
		/* -- getters -- */
		
		public function get wiimote():Wiimote { return _wiimote; }
		public function get controller():String { return _controller; }
		public function get textLine():TextLine { return _textLine; }
		
	}
}
